<template>
  <div class="wrapper" :class="[{ 'nav-open': $sidebar.showSidebar }]">
    <notifications></notifications>
    <side-bar v-bind:configs="configs">
      <div class="user">
        <div class="photo">
          <img
            v-if="current_user && current_user.hasOwnProperty('icon_image_url')"
            :src="current_user.icon_image_url"
            alt="avatar"
            decoding="async"
          />
        </div>
        <div class="user-info">
          <a href="/console/users/@me">
            <span v-if="current_user && current_user.hasOwnProperty('name')">
              {{ current_user.name }}
            </span>
          </a>
        </div>
      </div>

      <!--
      <mobile-menu></mobile-menu>
      -->

      <template v-if="current_user && configs" slot="links">
        <sidebar-item
          id="dashboard"
          :link="{
            name: $t('dashboard'),
            icon: 'home',
            path: '/console/libraries',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.activity"
          :link="{
            name: $t('activity'),
            icon: 'timeline',
            path: '/console/activity',
          }"
        ></sidebar-item>

        <sidebar-item
          v-if="configs.sidebar_items.my_classrooms"
          id="my_classrooms"
          :link="{
            name: $t('my_classrooms'),
            icon: 'perm_contact_calendar',
            path: '/console/my_classrooms',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.classrooms"
          id="classrooms"
          :link="{
            name: $t('class'),
            custom_icon: 'add_event',
            path: '/console/classrooms',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.contents_setting"
          id="categories_select"
          :link="{
            name: $t('contents_setting'),
            custom_icon: 'play',
            path: '/console/contents_setting',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.devices"
          id="devices"
          :link="{
            name: $t('devices'),
            custom_icon: 'device',
            path: '/console/devices',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.team_devices"
          id="team_devices"
          :link="{
            name: $t('devices'),
            custom_icon: 'device',
            path: '/console/team_devices',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.students"
          id="students"
          :link="{
            name: $t('students'),
            custom_icon: 'students',
            path: '/console/students',
          }"
        ></sidebar-item>

        <sidebar-item
          v-if="configs.sidebar_items.channels"
          :link="{
            name: $t('channels'),
            icon: 'video_library',
            path: '/console/channels',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.videos"
          id="videos"
          :link="{
            name: $t('videos'),
            icon: 'movie',
            path: '/console/videos',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.servers"
          id="cloud_archive"
          :link="{
            name: $t('cloud_archive'),
            icon: 'cloud_queue',
            path: '/console/servers',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.vr_recs"
          id="vr_recs"
          :link="{
            name: $t('vr_recs'),
            icon: 'radio_button_checked',
            path: '/console/vr_recs/',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.teams"
          id="teams"
          :link="{
            name: $t('contractor_info'),
            icon: 'domain',
            path: '/console/teams',
          }"
        ></sidebar-item>
        <sidebar-item
          v-if="configs.sidebar_items.users"
          id="users"
          :link="{
            name: $t('users'),
            icon: 'group',
            path: '/console/users',
          }"
        ></sidebar-item>

        <li v-if="configs.sidebar_items.user_guide" tag="li" class="">
          <a
            :href="'https://jollygoodplus.zendesk.com/'"
            class="nav-link"
            target="_blank"
          >
            <md-icon>import_contacts</md-icon>
            <p>{{ $t('user_guide') }}</p>
          </a>
        </li>
      </template>
    </side-bar>
    <div class="main-panel">
      <top-navbar
        :current_user="current_user"
        :configs="configs"
        :breadCrumbs="breadCrumbs"
      >
      </top-navbar>

      <div
        :class="{ content: !$route.meta.hideContent }"
        @click="toggleSidebar"
      >
        <zoom-center-transition :duration="200" mode="out-in">
          <router-view
            :current_user="current_user"
            :configs="configs"
            v-on:getBreadCrumbs="getBreadCrumbs"
          ></router-view>
        </zoom-center-transition>
      </div>
      <content-footer v-if="!$route.meta.hideFooter" :configs="configs">
      </content-footer>
    </div>
  </div>
</template>
<script>
import '/src/packs/dashboard.css';
import '/src/packs/dashboard_overrides.scss';
import '/src/packs/form.css';
import { mapActions, mapGetters } from 'vuex';
/* eslint-disable no-new */
import PerfectScrollbar from 'perfect-scrollbar';
import 'perfect-scrollbar/css/perfect-scrollbar.css';

function hasElement(className) {
  return document.getElementsByClassName(className).length > 0;
}

function initScrollbar(className) {
  if (hasElement(className)) {
    new PerfectScrollbar(`.${className}`);
  } else {
    // try to init it later in case this component is loaded async
    setTimeout(() => {
      initScrollbar(className);
    }, 100);
  }
}

import TopNavbar from './TopNavbar.vue';
import ContentFooter from './ContentFooter.vue';
import { ZoomCenterTransition } from '@/components/Transitions';
import moment from 'moment-timezone';

export default {
  data() {
    return {
      // current_user: null,
      configs: null,
      breadCrumbs: [],
    };
  },
  components: {
    TopNavbar,
    ContentFooter,
    ZoomCenterTransition,
  },
  computed: {
    ...mapGetters(['currentUser']),
    current_user() {
      return this.currentUser;
    },
  },
  methods: {
    ...mapActions([
      'storeCurrentPath',
      'fetchCurrentUser',
      'fetchConsoleConfigs',
    ]),

    toggleSidebar() {
      if (this.$sidebar.showSidebar) {
        this.$sidebar.displaySidebar(false);
      }
    },
    getBreadCrumbs(breadCrumbs) {
      this.breadCrumbs = breadCrumbs;
    },
    loadConsoleConfigs() {
      // config情報を取得
      this.fetchConsoleConfigs()
        .then((e) => {
          this.configs = e.data;
        })
        .catch((e) => {
          this.displayErrorNotify(e);
        });

      let docClasses = document.body.classList;
      docClasses.add('perfect-scrollbar-off');
    },
  },
  mounted() {
    // ログインしているユーザーの情報を取得
    this.fetchCurrentUser()
      .then(() => {
        this.$i18n.locale = this.currentUser.language;
        moment.locale(this.currentUser.language);
        moment.tz.setDefault(this.currentUser.full_time_zone);

        this.loadConsoleConfigs();
      })
      .catch((err) => {
        if (e.response) {
          if (err == 'Error: Request failed with status code 401') {
            const currentPath = this.$router.history.current.fullPath;
            this.storeCurrentPath(currentPath);
            console.log('current path = ', currentPath);
            this.$router.push({ name: 'sign_in' });
          }
          this.displayErrorNotify(new Error('ログインしてください'));
        }
      });
  },
};
</script>

<style lang="scss" scoped>
$scaleSize: 0.95;
@keyframes zoomIn95 {
  from {
    opacity: 0;
    transform: scale3d($scaleSize, $scaleSize, $scaleSize);
  }
  to {
    opacity: 1;
  }
}
.main-panel .zoomIn {
  animation-name: zoomIn95;
}
@keyframes zoomOut95 {
  from {
    opacity: 1;
  }
  to {
    opacity: 0;
    transform: scale3d($scaleSize, $scaleSize, $scaleSize);
  }
}
.main-panel .zoomOut {
  animation-name: zoomOut95;
}
a.nav-link:hover {
  opacity: 100;
}
@import url('https://fonts.googleapis.com/css?family=Roboto:300,400,500,700,300italic,400italic');
</style>
